//main.c
#include <sys/types.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include <pthread.h>
#include "config.h"
#include <stdio.h>
#include <string.h>
#include "main.h"
#include "wmem.h"
#include "net.h"
#include "version.h"

pthread_mutex_t         MainMutex;
char 			FServConn[256];
char			clcmd[256];
char			clcmd_on;
int 			scnt;


int main(int argc, char **argv)
{
	//int res;
	scnt = 1;
	//
	if(argc < 2)
	{
		printf(__err1__);
		return 1;
	}
	//
	workmode	= _workmode_no;
	meminfo();
	wmem.local_memsize	= wmem.sz_usr_memRAM;
	memset(&SEMAPHORE_NAME[0], 0, 256);
	memset(&SHARED_MEMORY_OBJECT_NAME[0], 0, 256);
	SHARED_MEMORY_OBJECT_SIZE	= 0;
	cserver.lport	= _ip_port_def;
	CSInit();
	clcmd_on	= 0;
	//
	while (scnt < argc)
	{
		//подсказка
		if(strcmp(argv[scnt], "--help") == 0)
		{
			printf(__help__);
			return 0;
		}
		//версия
		else if(strcmp(argv[scnt], "--version") == 0)
		{
			printf("version:%s date:%s\n", _version, _date);
			return 0;
		}
		//информация о рессурсах
		else if(strcmp(argv[scnt],"--info") == 0)
		{
			info();
			return 0;
		}
		//режим сервера связи
		else if(strcmp(argv[scnt],"--srvcon") == 0)
			workmode	= _workmode_srvcon;
		//режим клиента
		else if(strcmp(argv[scnt],"--cletcp") == 0)
			workmode	= _workmode_cletcp;
		//режим клиента SHM
		else if(strcmp(argv[scnt],"--cleshm") == 0)
			workmode	= _workmode_cleshm;
		else if(strcmp(argv[scnt],"-smfshm") == 0)
		{
			scnt++;
			if(!(scnt < argc))
                                return 2;
			strcpy(&SEMAPHORE_NAME[0], argv[scnt]);
		}
		else if(strcmp(argv[scnt],"-nshm") == 0)
		{
			scnt++;
			if(!(scnt < argc))
                                return 2;
			strcpy(&SHARED_MEMORY_OBJECT_NAME[0], argv[scnt]);
		}
		else if(strcmp(argv[scnt],"-szshm") == 0)
		{
			scnt++;
			if(!(scnt < argc))
                                return 2;
			SHARED_MEMORY_OBJECT_SIZE = atoi(argv[scnt]);
		}
		//текстовые команды от конечной точки
		else if(strcmp(argv[scnt],"-clcmd") == 0)
		{
			scnt++;
			clcmd_on	= 0xFF;
			if(!(scnt < argc))
                                return 2;
			memset(&clcmd[0], 0, 255);
			strcpy(&clcmd[0], argv[scnt]);
		}
		//принудительны IP для удаленного сервера, к
		//которому производим подключение из своего сервера
                else if(strcmp(argv[scnt], "-sip") == 0)
                {
                        scnt++;
                        if(!(scnt < argc))
                                return 2;
                }
		//Порт сервера к котому будем подключаться из своего сервера
		//или конечной точки
                else if(strcmp(argv[scnt], "-sp") == 0)
                {
                        scnt++;
                        if(!(scnt < argc))
                                return 2;
                        cserver.lport = atoi(argv[scnt]);
                        if(cserver.lport == 0)
                        	return 3;
                }
		/*
		//IP  для кодключения клиента
                else if(strcmp(argv[scnt], "-cip") == 0)
                {
                        scnt++;
                        if(!(scnt < argc))
                                return 2;
                }
		//Порт для кодключения клиента
                else if(strcmp(argv[scnt], "-cp") == 0)
                {
                        scnt++;
                        if(!(scnt < argc))
                                return 2;
                        //cclient.ipport = atoi(argv[scnt]);
                        //if(cclient.ipport == 0)
                        //        return 3;
                }
		*/
		else
		{
			printf(__err2__);
			return 2;
		}
		scnt++;
	}
	//
	switch(workmode)
	{
		case _workmode_srvcon:	//режим сервера связи
			memcreate();	//выделение памяти
			cserver.csmode	= _cmode_con;
			CSStart();	//стрт сервера
			break;
		case _workmode_cletcp:
			printf("client\n");
			if(clcmd_on)
				fclcmd();
			workmode	= 0;
			break;
		case _workmode_cleshm:	//клиент для разделяемой памяти
			if((strcmp(&SEMAPHORE_NAME[0], "") == 0) ||
			(strcmp(&SHARED_MEMORY_OBJECT_NAME[0], "") == 0) || 
			(SHARED_MEMORY_OBJECT_SIZE == 0))
			{
				printf("не определены параметры разделяемой памяти\n");
				return 11;
			}
			SshMemCreate();
			workmode	= 0;
			break;
		default:
			printf("не указан режим работы\n");
			return 10;	//не определён режим
	}
	//
	while(workmode > 0)
	{
		usleep(_main_sleep);
	}
	if(wmem.stat & _memuse)
		memfree();
	return 0;
}

int info(void)
{
	u_int8_t err = meminfo();
	switch(err)
	{
		case _ok:
			printf("Доступно памяти:   \t %lu\n", wmem.s_info.freeram);
			printf("Можно использовать:\t %llu ( 1 / %u от доступной )\n", wmem.sz_usr_memRAM, _Kmemmax);
			break;
		case _sysinfo_err:
			printf("Ошибка функции определения размера свободной памяти\n");
			break;
		default:
			printf("Не определённая ошибка при определении размера свободной памяти\n");
			break;
	}
	return 0;
}

int fclcmd(void)
{
	int res = 0;
	if(strcmp(&clcmd[0], "test") == 0)
	{
		printf("--test--\n");
	}
	else
	{
		printf("Команда не определена\n");
		res = 1;
	}
	return res;
}


