//net.h
#ifndef __net_h__
#define __net_h__
#include "config.h"

/*
==== формат TCP пакета ====
***Заголовок***
char		name[5] = {"ipmem"}	0x00000000	условное имя протокола размер 5 символов
u_int8_t	res1[3]			0x00000005	выравнивание до 8
u_int32_t	size			0x00000008	полный размер пекета
u_int8_t	mode			0x0000000C	режим рпботы
***Данные***
u_int8_t	data[]			0x00000020	адрес начала данных
=== формат данных ===
u_int8_t	dtype			0x00000020	тип обращения
u_int8_t	dcmd			0x00000021	команда
U_int8_t	resd[			0x00000022
*/


/***********************************/
//структура для сервера
typedef struct _SERVER
{
	u_int32_t	startIP;		//IP предыдущего узла
	u_int32_t	reserve32_1;
	u_int32_t	stopIP;			//IP последующего узла
	u_int32_t	reserve32_2;
	u_int16_t	port;
} SERVER;
//
typedef struct _CSERVER
{
	SERVER		server[_max_clients];
	u_int16_t	lport;			//порт прослушивания
	u_int16_t	cntclients;		//счётчик клиентов
#define _csflag_listen		0x0001		//флаг работы прослушивания
#define _csflag_cserver		0x0002		//флаг работы потоков подключений к серверу
	u_int16_t	csflag;			//флаг режимов работы
#define _cmode_off		0x00		//нет работы сервера
#define _cmode_con		0x01		//режим автономного сервера связи 
#define _cmode_man		0x02		//ручной режим работы сервера(ручные настройки подключений)
	u_int8_t	csmode;			//режим работы сервера
} CSERVER;
extern CSERVER cserver;

//структура для клиента
typedef struct _CLIENT
{
	u_int32_t	startIP;		//IP предыдущего узла
	u_int32_t	reserve32_1;
	u_int32_t	stopIP;			//IP последующего узла
	u_int32_t	reserve32_2;
	u_int16_t	port;
} CLIENT;
extern CLIENT client;


/************************************************/
//структура для конечной точки - мы пользователь
typedef struct _ENDPOINT
{
	u_int32_t	IP;			//адрес для подключения
	u_int32_t	reserve32_1;
	u_int16_t	port;			//порт для подключения
} ENDPOINT;
extern ENDPOINT endpoint;
//режим работы приложения
#define	_workmode_no		0x00	//нет режима запуска
#define _workmode_srvcon	0x01	//режим сервера связи
#define _workmode_srvm		0x02	//сервер с ручными настройками
#define _workmode_cletcp	0x10	//клиент-конечная точка с доступом к данным по TCP
#define _workmode_cleshm	0x11	//клиент-конечная точка с доступом к данным по SHM
#define _workmode_cletcpshm	0x12	//клиент-конечная точка с доступом к данным по TCP+SHM
extern u_int8_t	workmode;

/*
inline int cReadSocket(int nSocket, BYTE *pBuffer)
{
        //int     res                     = 1;
        int     	iRC                     = 0;
        int     	iReceiveStatus          = 0;
        int     	iStillToReceive         = 2; //начальный размер получения минимальных данных
        int     	iCount = 0;
        struct timeval 	ReceiveTimeout;
        fd_set 		fds;
	U8		flag			= 0;
	//fcntl(nSocket, F_SETFL, O_NONBLOCK);
        //fds = calloc(1, sizeof(fd_set));// fds;
        //int size = 0;
        while(iStillToReceive > 0)
        {
                //установка величины таймаута
                FD_ZERO(&fds);
                FD_SET(nSocket, &fds);
                ReceiveTimeout.tv_sec  = 0;
                ReceiveTimeout.tv_usec = _SOCKET_TIMEOUT_;
                iRC = select(nSocket + 1, &fds, NULL, NULL, &ReceiveTimeout);
                //выход по таймауту
                if(!iRC)
			return -1;
		//произошла какая то ошибка
                if(iRC < 0)
                        return -2;
		//ошибка указания размера данных
                if(iStillToReceive <= 0)
                        return -3;
                //прием нескольких байт
		#if(_tcp_recv_deb == 1)
			printf("----read sock (recv) ----\r\n");
        	#endif
		iReceiveStatus = recv(nSocket, (char*)(pBuffer), iStillToReceive, 0);
                if(iReceiveStatus >  0)
                {
			pBuffer += iReceiveStatus;
                        iStillToReceive -= iReceiveStatus;
                        iCount += iReceiveStatus;
			if((iCount >= 2) && (flag == 0))
			{ 
				iStillToReceive = (*(U16*)(pBuffer - iCount)) - iCount;
				#if(_tcp_recv_deb == 1)
					printf("---recv size: set %i, count %i, still %i\r\n", (*(U16*)(pBuffer - iCount)), iCount, iStillToReceive);
				#endif
				flag = 0xFF;
			}
                }
		else if(iReceiveStatus == 0)
			return -1;
		else
			return -2;
		#if(_tcp_recv_deb == 1)
			printf("==iStillToReceive:%i iCount:%i==\r\n", iStillToReceive, iCount);
		#endif
        }
        //
        return iCount;
}

inline int cWriteSocket(int nSocket, BYTE *pBuffer, U16 iMessageLength)
{
 	int 		iCount		= 0;
        int 		iSC 		= 0;
        int 		iSendStatus 	= 0;
        struct timeval 	SendTimeout;
        fd_set 		fds;
	//fcntl(nSocket, F_SETFL, O_NONBLOCK);
        while(iMessageLength > 0)
        {
		//установка величины таймаута
        	SendTimeout.tv_sec  = 0;
        	SendTimeout.tv_usec = _SOCKET_TIMEOUT_;
        	FD_ZERO(&fds);
        	FD_SET(nSocket, &fds);
                iSC = select(nSocket + 1, NULL, &fds, NULL, &SendTimeout);
                if(!iSC)
                        return -1; //таймаут
                if(iSC < 0)
                        return -2; //ошибка
		//отправить несколько байт
		#if(_tcp_send_deb == 1)
			printf("----write sock (send) ----\r\n");
                #endif
		iSendStatus = send(nSocket, (char*)(pBuffer), iMessageLength, 0);
                if(iSendStatus > 0)
                {
                        //обновить буфер и счетчик
                        iMessageLength -= iSendStatus;
                        pBuffer += iSendStatus;
                        iCount += iSendStatus;
                }
		else if(iSendStatus == 0)
			return -1;
		else
			return -2;
        }
	return iCount;
}
*/


//начальная инициализация
extern void CSInit(void);
//сервер - старт
extern int CSStart(void);
//сервер - прослушивание
extern void CSListen(void);

#endif

