//wmem.c
#include <unistd.h>
#include <sys/types.h>
#include <linux/unistd.h>       /* for _syscallX macros/related stuff */
#include <linux/kernel.h>       /* for struct sysinfo */
#include <sys/sysinfo.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "config.h"
#include "wmem.h"
#include "net.h"
#include "imclient.h"

WMEM 			wmem;
u_int8_t		* wram;


char 		SEMAPHORE_NAME[256];			// "/test_named_semaphore"
char 		SHARED_MEMORY_OBJECT_NAME[256]; 	// "test_shared_memory"
u_int64_t	SHARED_MEMORY_OBJECT_SIZE;

SSHM sshm;
//sem_t 		*sem;
//int 		shm;

/*Если sysinfo отсутствует в kernel.h, последнее заменить на sys/sysinfo.h
 
 _syscall1(int, sysinfo, struct sysinfo *, info);
 
Note: if you copy directly from the nroff source, remember to*/

/*
запрос доступной памяти
и определение размера для выделения
*/
u_int8_t meminfo(void)
{
 	int merror;
 	merror = (int)(sysinfo( &wmem.s_info )); 
	if ( merror != 0 )
		wmem.stat		|= _sysinfo_err;
	else
	{
		wmem.stat		= _sysinfo_err;
		wmem.sz_usr_memRAM 	= (u_int64_t)(wmem.s_info.freeram / _Kmemmax);
		wmem.stat		|= _ok;
	}
	return( wmem.stat );
}

void memcreate(void)
{
	wram	= (u_int8_t*)malloc(wmem.local_memsize);
	switch(workmode)
	{
		case _workmode_srvcon:
			wmem.local_start_addr	= 0;
			wmem.local_stop_addr	= wmem.local_start_addr + wmem.local_memsize;
			break;
		default:
			break;
	}
}

void		memfree(void)
{
	free(wram);
}

/*

*/
//формирование разделяемой памяти
int SshMemCreate(void)
{
	int res;
	res = _SshMemCreate(&SHARED_MEMORY_OBJECT_NAME[0], &SEMAPHORE_NAME[0], SHARED_MEMORY_OBJECT_SIZE, &sshm);
	//память - создание
	switch(res)
	{
		case 1:
			printf("Ошибка создания разделяемой памяти\n");
			break;
		case 2:
			printf("Ошибка размера создаваемой памяти\n");
			break;
		case 3:
			printf("Ошибка создания семафора\n");
			break;
		default:
			break;
	}
	//
	return res;
}



