//wmem.h

/*
	Работа с памятью
*/

#ifndef _wmem_h_
#define _wmem_h_

#include <sys/types.h>
#include <linux/unistd.h>       /* for _syscallX macros/related stuff */
#include <linux/kernel.h>       /* for struct sysinfo */ 

typedef struct _WMEM
{
	struct sysinfo	s_info;
	u_int64_t	sz_usr_memRAM;		//допустимый размер выделяемой памяти
	u_int64_t	local_memsize;		//локальный размер памяти
	u_int64_t	local_start_addr;	//локальный начальный адрес памяти
	u_int64_t	local_stop_addr;	//локальный конечный адрес памяти
#define	_ok		0x00			//инициализация и инфо прошли нормально
#define _sysinfo_err	0x01			//ошибка инициализации и проверки
#define _memuse		0x80			//
	u_int8_t	stat;
} WMEM;
extern WMEM 		wmem;
extern u_int8_t		* wram;

/*******************************************
секция разделяемой памяти для конечной точки
********************************************/
extern char 		SEMAPHORE_NAME[256];			// "/test_named_semaphore"
extern char 		SHARED_MEMORY_OBJECT_NAME[256]; 	// "test_shared_memory"
extern u_int64_t	SHARED_MEMORY_OBJECT_SIZE;
//формирование разделяемой памяти
extern int 		SshMemCreate(void);


extern	u_int8_t 	meminfo(void);
extern void 		memcreate(void);
extern void		memfree(void);



#endif

